<?php namespace Dever\Helper;
class Math
{
	# 笛卡尔积
    public static function cartesian($data)
    {
        $len = count($data);
        $result = array();
        if ($len == 1) {
            foreach ($data[0] as $k => $v) {
                if (is_array($v)) {
                    foreach ($v as $k1 => $v1) {
                        $v[$k1] = array($v1);
                    }
                }
                $result[] = $v;
            }
        } else {
            $k = 0;
            $result = $data[0];
            for ($i = 1; $i < $len; $i++) {
                $arr = $result;
                $result = [];
                foreach ($arr as $v) {
                    foreach($data[$i] as $v1) { 
                        if(!is_array($v)) {
                            $v = array($v);
                        }
                        if(!is_array($v1)){
                            $v1 = array($v1);
                        }
                        $result[] = array_merge_recursive($v, $v1);
                    }
                }
            }
        }
        return $result;
    }
    # 计算距离
    public static function distance($lng1, $lat1, $lng2, $lat2, $miles = true)
    {
        $pi80 = M_PI / 180;
        $lat1 *= $pi80;
        $lng1 *= $pi80;
        $lat2 *= $pi80;
        $lng2 *= $pi80;
        $r = 6372.797;
        $dlat = $lat2 - $lat1;
        $dlng = $lng2 - $lng1;
        $a = sin($dlat/2)*sin($dlat/2)+cos($lat1)*cos($lat2)*sin($dlng/2)*sin($dlng/2);
        $c = 2 * atan2(sqrt($a), sqrt(1 - $a));
        $km = $r * $c;
        if ($miles) {
            $km = $km * 0.621371192;
        }
        return $km;
    }
    # 将数值金额转换为中文大写金额
    public static function convertNum($amount, $type = 1) {
        if (!is_numeric($amount) || strlen($amount) > 12) {
            return false;
        }
        if($amount == 0) {
            return "零元整";
        }
        $result = '';
        if($amount < 0) {
            $result = '负';
        }
        $digital = array('零', '壹', '贰', '叁', '肆', '伍', '陆', '柒', '捌', '玖');
        $position = array('仟', '佰', '拾', '亿', '仟', '佰', '拾', '万', '仟', '佰', '拾', '元');
        $amountArr = explode('.', $amount);
        $integerArr = str_split($amountArr[0], 1);
        $integerArrLength = count($integerArr);
        $positionLength = count($position);
        for ($i = 0; $i < $integerArrLength; $i++) {
            if ($integerArr[$i] != 0) {
                $result = $result . $digital[$integerArr[$i]] . $position[$positionLength - $integerArrLength + $i];
            } else {
                if (($positionLength - $integerArrLength + $i + 1)%4 == 0) {
                    $result = $result . $position[$positionLength - $integerArrLength + $i];
                }
            }
        }
        if ($type == 0) {
            $decimalArr = str_split($amountArr[1], 1);
            if ($decimalArr[0] != 0){
                $result = $result . $digital[$decimalArr[0]] . '角';
            }
            if ($decimalArr[1] != 0){
                $result = $result . $digital[$decimalArr[1]] . '分';
            }
        } else {
            $result = $result . '整';
        }
        return $result;
    }
}