<?php namespace Dever\Helper;
class Str
{
    public static function encode($string, $key = '')
    {
        return Secure::encode($string, $key);
    }
    public static function decode($string, $key = '')
    {
        return Secure::decode($string, $key);
    }
    public static function hide($string, $start = 3, $len = 4, $hide = '****')
    {
        return substr_replace($string, $hide, $start, $len);
    }
    public static function per($cash, $value)
    {
        if (strstr($value, '%')) {
            $value = str_replace('%', '', $value);
            $value = round($value/100, 2);
            $value = $value * $cash;
        }
        return round($value, 2);
    }
    public static function salt($len)
    {
        return bin2hex(random_bytes($len));
    }
    public static function rand($len, $type = 4)
    {
        $source = array("0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z");
        $config = array (
            0 => array("min" => 0, "max" => 9), /// 全数字
            1 => array("min" => 10, "max" => 35), /// 全小写
            2 => array("min" => 36, "max" => 61), /// 全大写
            3 => array("min" => 10, "max" => 61), /// 大小写
            4 => array("min" => 0, "max" => 61), /// 数字+大小写
        );
        if (!isset($config[$type])) {
            $type = 4;
        }
        $rand = "";
        for ($i = 0; $i < $len; $i++) {
            $rand .= $source[rand($config[$type]["min"], $config[$type]["max"])];
        }
        return $rand;
    }
    public static function order($prefix = '', $type = 1)
    {
        if ($type == 1) {
            return $prefix . date('Ymd').substr(time(), -5) . substr(microtime(), 2, 5) . sprintf('%02d', rand(1000, 9999));
        } elseif ($type == 2) {
            return $prefix . time() . substr(microtime(), 2, 5) . sprintf('%02d', rand(100000, 999999));
        } elseif ($type == 3) {
            return $prefix . date('Ymd').substr(implode(NULL, array_map('ord', str_split(substr(uniqid(), 7, 13), 1))), 0, 8);
        } elseif ($type == 4) {
            if (function_exists('session_create_id')) {
                return $prefix . strtolower(session_create_id());
            } else {
                $charid = strtolower(md5(uniqid(mt_rand(), true)));
                return $prefix . substr($charid, 0, 8) . substr($charid, 8, 4) . substr($charid, 12, 4) . substr($charid, 16, 4) . substr($charid, 20, 12);
            }
        }
    }
    public static function code($num = 4)
    {
        $code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $rand = $code[rand(0,25)]
            .strtoupper(dechex(date('m')))
            .date('d')
            .substr(time(),-5)
            .substr(microtime(),2,5)
            .sprintf('%02d',rand(0,99));
        for(
            $a = md5( $rand, true ),
            $s = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ',
            $d = '',
            $f = 0;
            $f < $num;
            $g = ord( $a[ $f ] ),
            $d .= $s[ ( $g ^ ord( $a[ $f + 8 ] ) ) - $g & 0x1F ],
            $f++
        );
        return $d;
    }
    public static function uid($uid, $type = 'encode')
    {
        $source_string = 'E5FCDG3HQA4B1NOPIJ2RSTUV67MWX89KLYZ';
        if ($type == 'encode') {
            $code = '';
            $num = $uid;
            while ($num > 0) {
                $mod = $num % 35;
                $num = ($num - $mod) / 35;
                $code = $source_string[$mod].$code;
            }
            if (empty($code[3])) {
                $code = str_pad($code,4,'0',STR_PAD_LEFT);
            }
            return $code;
        } else {
            $code = $uid;
            if (strrpos($code, '0') !== false)
            $code = substr($code, strrpos($code, '0')+1);
            $len = strlen($code);
            $code = strrev($code);
            $num = 0;
            for ($i=0; $i < $len; $i++) {
                $num += strpos($source_string, $code[$i]) * pow(35, $i);
            }
            return $num;
        }
    }
    public static function idtostr($id)
    {
        if (!is_numeric($id) || $id < 0) {
            return false;
        }
        $id = substr("00000000" . $id, -8);
        $sandNum = $id % 10;
        srand($id);
        $randstr = "" . rand(1, 9) . self::rand(7, 0);

        $retstr1 = "";
        $retstr2 = "";
        for ($i = 0; $i < 4; $i++) {
            $retstr1 .= $randstr[$i] . $id[$i];
            $retstr2 .= $id[7 - $i] . $randstr[7 - $i];
        }
        $retstr1 = substr(self::rand(6) . "g" . dechex($retstr1), -7);
        $retstr2 = substr(self::rand(6) . "g" . dechex($retstr2), -7);
        srand(time() + $id);
        $retstr = "1" . $sandNum;
        for ($i = 0; $i < 7; $i++) {
            $retstr .= $retstr1[$i] . $retstr2[$i];
        }
        return $retstr;
    }
    public static function strtoid($str)
    {
        if (strlen($str) != 16) {
            return $str;
        }
        //$type = $str1[0];
        $sandNum = $str[1];
        $retstr1 = $retstr2 = '';
        for ($i = 0; $i < 7; $i++) {
            if ($str[2+$i*2] == 'g') {
                $retstr1 = "";
            } else {
                $retstr1 .= $str[2+$i*2];
            }

            if ($str[3+$i*2] == 'g') {
                $retstr2 = "";
            } else {
                $retstr2 .= $str[3+$i*2];
            }
        }
        $retstr1 = "g".substr("00000000".hexdec($retstr1),-8);
        $retstr2 = "g".substr("00000000".hexdec($retstr2),-8);
        $ret1 = $ret2 = "";
        for ($i = 0; $i < 4; $i++) {
            $ret1 .= $retstr1[$i*2+2];
            $ret2 .= $retstr2[7-$i*2];
        }
        $ret = $ret1 * 10000 + $ret2;
        return $ret;
    }
    public static function cut($string, $length = 80, $etc = '...')
    {
        $result = '';
        $string = html_entity_decode(trim(strip_tags($string)), ENT_QUOTES, 'utf-8');
        for ($i = 0, $j = 0; $i < strlen($string); $i++) {
            if ($j >= $length) {
                for ($x = 0, $y = 0; $x < strlen($etc); $x++) {
                    if ($number = strpos(str_pad(decbin(ord(substr($string, $i, 1))), 8, '0', STR_PAD_LEFT), '0')) {
                        $x += $number - 1;
                        $y++;
                    } else {
                        $y += 0.5;
                    }
                }
                $length -= $y;
                break;
            }
            if ($number = strpos(str_pad(decbin(ord(substr($string, $i, 1))), 8, '0', STR_PAD_LEFT), '0')) {
                $i += $number - 1;
                $j++;
            } else {
                $j += 0.5;
            }
        }
        for ($i = 0; (($i < strlen($string)) && ($length > 0)); $i++) {
            if ($number = strpos(str_pad(decbin(ord(substr($string, $i, 1))), 8, '0', STR_PAD_LEFT), '0')) {
                if ($length < 1.0) {
                    break;
                }
                $result .= substr($string, $i, $number);
                $length -= 1.0;
                $i += $number - 1;
            } else {
                $result .= substr($string, $i, 1);
                $length -= 0.5;
            }
        }
        //$result = htmlentities($result, ENT_QUOTES, 'utf-8');
        if ($i < strlen($string)) {
            $result .= $etc;
        }
        return $result;
    }
    public static function length($string)
    {
        preg_match_all("/./us", $string, $match);
        return count($match[0]);
    }
    public static function addstr($str, $index, $sub)
    {
        $str = self::explode($str, 1);
        $length = count($str);
        $num = floor($length / $index);
        for ($a = 1; $a <= $num; $a++) {
            $start = '';
            $b = $a * $index;
            foreach ($str as $k => $v) {
                if ($k == $b) {
                    $str[$k] = $sub . $v;
                }
            }
        }
        return implode('', $str);
    }
    public static function explode($value, $num = 2)
    {
        $len = mb_strlen($value);
        $result = array();
        for ($i = 0; $i < $len; $i = $i + $num) {
            $result[$i / $num] = mb_substr($value, $i, $num);
        }
        return $result;
    }
    public static function ishtml($html)
    {
        if($html != strip_tags($html)) {
            return true;
        } else {
            return false;
        }
    }
    public static function encodePic($file, $type = 1)
    {
        $base64 = '';
        if (is_file($file)) {
            $info = getimagesize($file);
            $fp = fopen($file, "r");
            if ($fp) {
                $content = chunk_split(base64_encode(fread($fp, filesize($file))));
                switch ($info[2]) {
                    case 1: $img_type = 'gif';
                        break;
                    case 2: $img_type = 'jpg';
                        break;
                    case 3: $img_type = 'png';
                        break;
                }
                if ($type == 1) {
                    $base64 = 'data:image/' . $img_type . ';base64,' . $content;
                } else {
                    $base64 = $content;
                }
            }
            fclose($fp);
        }
        return $base64;
    }
}