<?php namespace Dever;
class Library
{
    protected static $class;
    protected static $load;
    public static function autoload($class)
    {
        if (empty(self::$load[$class])) {
            $class = explode('\\', $class);
            if (isset($class[3])) {
                self::require(lcfirst($class[0]), lcfirst($class[1]) . DIRECTORY_SEPARATOR . $class[2] . DIRECTORY_SEPARATOR . $class[3]);
            } elseif (isset($class[2])) {
                self::require(lcfirst($class[0]), lcfirst($class[1]) . DIRECTORY_SEPARATOR . $class[2]);
            }
        }
    }
    public static function require($app, $file)
    {
        $project = Project::load($app);
        if ($project) {
            require_once $project['path'] . $file . '.php';
        }
    }
    public static function apply($file, $app, $path)
    {
        if (strpos($file, '/')) {
            $class = str_replace(' ', '/', ucwords(str_replace('/', ' ', $file)));
            $file = $path . DIRECTORY_SEPARATOR . $class;
            $class = str_replace('/', '\\', $class);
        } else {
            $class = ucfirst($file);
            $file = $path . DIRECTORY_SEPARATOR . $file;
        }
        $class = ucfirst($app) . '\\' . ucfirst($path) . '\\' . $class;
        if (empty(self::$load[$class])) {
            self::$load[$class] = true;
            self::require($app, $file);
        }
        return $class;
    }
    public static function load($class, $app, $path)
    {
        $class = self::apply(ucfirst($class), $app, $path);
        if (empty(self::$class[$class])) {
            self::$class[$class] = new $class();
        }
        return self::$class[$class];
    }
}