<?php namespace Dever;
class Paginator
{
    protected static $status = false;
    protected static $num;
    protected static $rows;
    protected static $current;
    protected static $html = '';
    protected static $link;
    public static function init($num, $page, $rows)
    {
        self::$num = $num;
        self::$rows = $rows;
        self::$current = Route::input('pg', '', '', $page);
        $offset = self::$num * (self::$current-1);
        if ($offset >= 10000) {
            return array($offset, self::$num);
        }
        return $offset . ',' . self::$num;
    }
    public static function status($status)
    {
        self::$status = !$status;
    }
    public static function get($template = '', $maxpage = 10, $link = '')
    {
        if (self::$rows) {
            if ($template == 'total') {
                return (self::$rows)();
            }
            $page['num'] = self::$num;
            $page['status'] = self::$status;
            $page['current'] = self::$current;
            if ($template) {
                $page['rows'] = self::$rows = (self::$rows)();
                $page['next'] = $page['total'] = ceil(self::$rows / self::$num);
                if (self::$current < $page['total']) {
                    $page['next'] = self::$current+1;
                } else {
                    self::$current = $page['total'];
                }
                $page['prev'] = self::$current-1;
                if ($page['prev'] < 1) {
                    $page['prev'] = 1;
                }
                self::handle($page, $maxpage);
                $page['html'] = self::html($page, $template, $maxpage, $link);
            }
            return $page;
        }
        return false;
    }
    protected static function handle(&$page, $maxpage)
    {
        if ($page['total'] <= $maxpage) {
            $page['start'] = 1;
            $page['end'] = $page['total'];
        } else {
            $tpage = intval($maxpage / 2);
            if ($page['current'] < $tpage) {
                $page['start'] = 1;
            } elseif ($page['current'] <= ($page['total'] - $maxpage)) {
                $page['start'] = $page['current'] - $tpage;
            } elseif ($page['current'] > $page['total'] - $maxpage && $page['current'] <= $page['total'] - $tpage) {
                $page['start'] = $page['current'] - $tpage;
            } elseif ($page['current'] > $page['total'] - $tpage) {
                $page['start'] = $page['total'] - $maxpage + 1;
            }
            $page['end'] = $page['start'] + $maxpage - 1;
            if ($page['start'] < 1) {
                $page['end'] = $page['current'] + 1 - $page['start'];
                $page['start'] = 1;
                if (($page['end'] - $page['start']) < $maxpage) {
                    $page['end'] = $maxpage;
                }
            } elseif ($page['end'] > $page['total']) {
                $page['start'] = $page['total'] - $maxpage + 1;
                $page['end'] = $page['total'];
            }
        }
    }
    public static function link($page)
    {
        if (is_string(self::$link)) {
            return Route::url(self::$link, array('pg' => $page));
        }
        return (self::$link)($page);
    }
    protected static function html($page, $template, $maxpage, $link)
    {
        $file = DEVER_PROJECT_PATH . 'page/' . $template . '.php';
        if (is_file($file)) {
            $html = include $file;
            self::$link = $link;
            if (!self::$link) {
                self::$link = Route::url(false);
                if (strpos(self::$link, 'pg=') !== false) {
                    self::$link = preg_replace('/[?|&]pg=(\d+)/i', '', self::$link);
                }
            }
            if (is_array($html)) {
                self::template($html, $page);
            } else {
                self::$html = $html;
            }
        }
        return self::$html;
    }
    protected static function template($html, $page)
    {
        self::$html = '';
        if ($page['current'] > 1 && isset($html['start'])) {
            self::$html .= self::create($html['child'], $html['start'][1], 1, $html['start'][0], $html['page'][2]);
        }
        if (isset($html['prev'])) {
            self::$html .= self::create($html['child'], $html['prev'][1], $page['prev'], $html['prev'][0], $html['page'][2]);
        }
        $i = $page['start'];
        for ($i; $i <= $page['end']; $i++) {
            self::$html .= self::create($html['child'], self::getClass($i, $html['page'], $page), $i, $i, $html['page'][2]);
        }
        if (isset($html['next'])) {
            self::$html .= self::create($html['child'], $html['next'][1], $page['next'], $html['next'][0], $html['page'][2]);
        }
        if (isset($html['end']) && $page['current'] < $page['total']) {
            self::$html .= self::create($html['child'], $html['end'][1], $page['total'], $html['end'][0], $html['page'][2]);
        }
        if (isset($html['jump'])) {
            $click = 'onclick="var link=\'' . self::link('dever_page') . '\';location.href=link.replace(\'dever_page\', document.getElementById(\'dever_page\').value)"';
            self::$html .= str_replace('{click}', $click, $html['jump']);
        }
        self::$html = self::tag($html['parent'], self::$html);
    }
    protected static function create($child, $class, $num, $name, $type = '')
    {
        if ($type == 'parent') {
            $child[1] = 'class="' . $class . '"';
            $class = '';
        }
        return self::tag($child, self::getContent($child, $class, $num, $name));
    }
    protected static function tag($tag, $content)
    {
        if (!$tag) {
            return $content;
        }
        $attr = '';
        if (is_array($tag)) {
            $temp = $tag;unset($tag);
            $tag = $temp[0];
            $attr = $temp[1];
        }
        return '<' . $tag . ' ' . $attr . '>' . $content . '</' . $tag . '>';
    }
    protected static function getContent($child, $class, $num, $name)
    {
        if ($child && $child[0] == 'a') {
            $child[1] = self::attr($class, self::link($num));
            $content = $name;
        } else {
            $content = self::tag(array('a', self::attr($class, self::link($num))), $name);
        }
        return $content;
    }
    protected static function attr($class, $href)
    {
        return ' class="' . $class . '" href="' . $href . '" ';
    }
    protected static function getClass($index, $html, $page)
    {
        $class = $html[0];
        if ($index == $page['current']) {
            if (isset($html[3]) && $html[3] == true) {
                $class = $html[1];
            } else {
                if ($class) {
                    $class .= ' ';
                }
                $class .= $html[1];
            }
        }
        return $class;
    }
}