<?php namespace Dever;
class View
{
    public static function show($file, $data, $app = '', $path = 'assets')
    {
        if (!$app) {
            $app = DEVER_APP_NAME;
        }
        $project = Project::load($app);
        $template = self::template();
        $path = $path . DIRECTORY_SEPARATOR . $template . DIRECTORY_SEPARATOR;
        if (strstr($project['path'], 'package')) {
            $package_path = str_replace(DEVER_PATH, '', $project['path']);
            $package_host = DEVER_PROTO . '://' . $_SERVER['HTTP_HOST'] . '/dever2/' . $package_path . $path;
        }
        $host = $project['url'] . $path;
        $compile = File::get('compile' . DIRECTORY_SEPARATOR . $app . DIRECTORY_SEPARATOR . $template . DIRECTORY_SEPARATOR . $file . '.php');
        Debug::add($compile, 'template');
        if (Debug::$shell) {
            return $data;
        }
        $template = $project['path'] . $path . 'template' . DIRECTORY_SEPARATOR . $file . '.html';
        if (!is_file($template)) {
            Output::error('file not exists');
        }
        $create = true;
        if (is_file($compile) && filemtime($compile) >= filemtime($template)) {
            $create = false;
        }
        if ($create) {
            self::create($template, $compile);
        }
        include($compile);die;
    }
    private static function template()
    {
        $template = 'default';
        if (isset(Config::get('setting')['template']['name']) && Config::get('setting')['template']['name']) {
            $template = Config::get('setting')['template']['name'];
            if (strpos($template, ',')) {
                $temp = explode(',', $template);
                if (\Dever\Helper\Env::mobile()) {
                    $template = $temp[1];
                } else {
                    $template = $temp[0];
                }
            }
        }
        return $template;
    }
    private static function create($template, $compile)
    {
        $content = file_get_contents($template);
        if (isset(Config::get('setting')['template']['replace'])) {
            foreach (Config::get('setting')['template']['replace'] as $k => $v) {
                $content = str_replace($k, $v, $content);
            }
        }
        $content = str_replace('{endforeach}', '<?php endforeach;?>', $content);
        $content = str_replace('{endif}', '<?php endif;?>', $content);
        $content = preg_replace('/{foreach(.*?)}/', '<?php foreach($1):?>', $content);
        $content = preg_replace('/{if(.*?)}/', '<?php if($1):?>', $content);
        $content = preg_replace('/{\$([a-zA-Z0-9_\'\"\[\]\s]+)}/', '<?php echo \$$1; ?>', $content);
        $content = preg_replace('/{\$(.*?)([\=|\-|\-\-|\+|\+\+|\*|\/])(.*?)}/', '<?php \$$1$2$3; ?>', $content);
        $content = preg_replace('/{Dever::(.*?)}/', '<?php echo Dever::$1; ?>', $content);
        file_put_contents($compile, '<!--power by dever '.date('Y-m-d H:i:s').'-->'.$content);
    }
}